package infrastructure

import (
	"errors"

	"code.osinet.fr/fgm/kurz/domain"
)

type urlmap map[domain.URL]domain.URL

var targets = make(urlmap)
var shorts = make(urlmap)

type MemoryShortURLRepository struct {
}

type MemoryTargetURLRepository struct {

}

func (r MemoryShortURLRepository) GetTarget(su domain.ShortURL) (domain.TargetURL, error) {
	var tu domain.TargetURL
	var err error

	if t, ok := targets[su.URL]; ok {
		tu = domain.TargetURL{URL: t}
	} else {
		err = errors.New("not found")
	}
	return tu, err
}

func (s MemoryTargetURLRepository) GetShort(tu domain.TargetURL) (su domain.ShortURL, isNew bool, err error) {
	// If short exists, just return it.
	if s, ok := shorts[tu.URL]; ok {
		su = domain.ShortURL{URL: s}
		return su, false, err
	}

	// If it doesn't exist, attempt to create it.
	su, err = domain.NewUnspecifiedShortURL(tu)
	if err != nil {
		// Creation failed.
		return su, false, err
	}

	shorts[tu.URL] = su.URL
	targets[su.URL] = tu.URL

	return su, true, err
}

